#include <stdio.h>
#include <errno.h>
#include <string>
#include <strstream>

void fatal(const string &x)
{
  fprintf(stderr,"\n\nFatal error:\n%s\n\n",x.c_str());
  exit(1);
};

void fatalerrno(const string &x)
{
  fprintf(stderr,"\n\nFatal error:\n%s\n\nErrno = %s\n\n",x.c_str(),strerror(errno));
  exit(1);
};

int main(int argc, char *argv[])
{
  if (argc!=4) fatal("randjoin infileprefix outfile numinfiles\nexample: randjoin base secret 10");
  
  FILE *out=fopen(argv[2],"wb");
  if (out==0) fatalerrno("cannot open outfile");
  
  FILE *in[256];
  int numin=atol(argv[3]);
  if (numin<1) fatal("numinfiles must be at least 1");
  for (int a=0;a<numin;++a) {
    string name(argv[1]);
    strstream s;
    s<<a;
    name+=s.str();
    in[a]=fopen(name.c_str(),"rb");
    if (in[a]==0) fatalerrno("cannot open one of the infiles");
  };
  
  for (;;) {
    unsigned char v;
    if (fread(&v,1,1,in[0])!=1) break;
    
    for (int a=1;a<numin;++a) {
      unsigned char r;
      fread(&r,1,1,in[a]);
      v^=r;
    };
    
    fwrite(&v,1,1,out);
  };
  

  for (int a=0;a<numin;++a) fclose(in[a]);
  
  fclose(out);
  
  return 0;
};
